package bops

import "strings"

// Str takes a slice of bytes in big-endian representation and
// returns a binary representation of the value as string.
func Str(a []byte) string {
	var sb strings.Builder

	for _, b := range a {
		sb.Write(byteStrings[b])
	}

	return sb.String()
}

var byteStrings = [256][]byte{
	[]byte("00000000"),
	[]byte("00000001"),
	[]byte("00000010"),
	[]byte("00000011"),
	[]byte("00000100"),
	[]byte("00000101"),
	[]byte("00000110"),
	[]byte("00000111"),
	[]byte("00001000"),
	[]byte("00001001"),
	[]byte("00001010"),
	[]byte("00001011"),
	[]byte("00001100"),
	[]byte("00001101"),
	[]byte("00001110"),
	[]byte("00001111"),
	[]byte("00010000"),
	[]byte("00010001"),
	[]byte("00010010"),
	[]byte("00010011"),
	[]byte("00010100"),
	[]byte("00010101"),
	[]byte("00010110"),
	[]byte("00010111"),
	[]byte("00011000"),
	[]byte("00011001"),
	[]byte("00011010"),
	[]byte("00011011"),
	[]byte("00011100"),
	[]byte("00011101"),
	[]byte("00011110"),
	[]byte("00011111"),
	[]byte("00100000"),
	[]byte("00100001"),
	[]byte("00100010"),
	[]byte("00100011"),
	[]byte("00100100"),
	[]byte("00100101"),
	[]byte("00100110"),
	[]byte("00100111"),
	[]byte("00101000"),
	[]byte("00101001"),
	[]byte("00101010"),
	[]byte("00101011"),
	[]byte("00101100"),
	[]byte("00101101"),
	[]byte("00101110"),
	[]byte("00101111"),
	[]byte("00110000"),
	[]byte("00110001"),
	[]byte("00110010"),
	[]byte("00110011"),
	[]byte("00110100"),
	[]byte("00110101"),
	[]byte("00110110"),
	[]byte("00110111"),
	[]byte("00111000"),
	[]byte("00111001"),
	[]byte("00111010"),
	[]byte("00111011"),
	[]byte("00111100"),
	[]byte("00111101"),
	[]byte("00111110"),
	[]byte("00111111"),
	[]byte("01000000"),
	[]byte("01000001"),
	[]byte("01000010"),
	[]byte("01000011"),
	[]byte("01000100"),
	[]byte("01000101"),
	[]byte("01000110"),
	[]byte("01000111"),
	[]byte("01001000"),
	[]byte("01001001"),
	[]byte("01001010"),
	[]byte("01001011"),
	[]byte("01001100"),
	[]byte("01001101"),
	[]byte("01001110"),
	[]byte("01001111"),
	[]byte("01010000"),
	[]byte("01010001"),
	[]byte("01010010"),
	[]byte("01010011"),
	[]byte("01010100"),
	[]byte("01010101"),
	[]byte("01010110"),
	[]byte("01010111"),
	[]byte("01011000"),
	[]byte("01011001"),
	[]byte("01011010"),
	[]byte("01011011"),
	[]byte("01011100"),
	[]byte("01011101"),
	[]byte("01011110"),
	[]byte("01011111"),
	[]byte("01100000"),
	[]byte("01100001"),
	[]byte("01100010"),
	[]byte("01100011"),
	[]byte("01100100"),
	[]byte("01100101"),
	[]byte("01100110"),
	[]byte("01100111"),
	[]byte("01101000"),
	[]byte("01101001"),
	[]byte("01101010"),
	[]byte("01101011"),
	[]byte("01101100"),
	[]byte("01101101"),
	[]byte("01101110"),
	[]byte("01101111"),
	[]byte("01110000"),
	[]byte("01110001"),
	[]byte("01110010"),
	[]byte("01110011"),
	[]byte("01110100"),
	[]byte("01110101"),
	[]byte("01110110"),
	[]byte("01110111"),
	[]byte("01111000"),
	[]byte("01111001"),
	[]byte("01111010"),
	[]byte("01111011"),
	[]byte("01111100"),
	[]byte("01111101"),
	[]byte("01111110"),
	[]byte("01111111"),
	[]byte("10000000"),
	[]byte("10000001"),
	[]byte("10000010"),
	[]byte("10000011"),
	[]byte("10000100"),
	[]byte("10000101"),
	[]byte("10000110"),
	[]byte("10000111"),
	[]byte("10001000"),
	[]byte("10001001"),
	[]byte("10001010"),
	[]byte("10001011"),
	[]byte("10001100"),
	[]byte("10001101"),
	[]byte("10001110"),
	[]byte("10001111"),
	[]byte("10010000"),
	[]byte("10010001"),
	[]byte("10010010"),
	[]byte("10010011"),
	[]byte("10010100"),
	[]byte("10010101"),
	[]byte("10010110"),
	[]byte("10010111"),
	[]byte("10011000"),
	[]byte("10011001"),
	[]byte("10011010"),
	[]byte("10011011"),
	[]byte("10011100"),
	[]byte("10011101"),
	[]byte("10011110"),
	[]byte("10011111"),
	[]byte("10100000"),
	[]byte("10100001"),
	[]byte("10100010"),
	[]byte("10100011"),
	[]byte("10100100"),
	[]byte("10100101"),
	[]byte("10100110"),
	[]byte("10100111"),
	[]byte("10101000"),
	[]byte("10101001"),
	[]byte("10101010"),
	[]byte("10101011"),
	[]byte("10101100"),
	[]byte("10101101"),
	[]byte("10101110"),
	[]byte("10101111"),
	[]byte("10110000"),
	[]byte("10110001"),
	[]byte("10110010"),
	[]byte("10110011"),
	[]byte("10110100"),
	[]byte("10110101"),
	[]byte("10110110"),
	[]byte("10110111"),
	[]byte("10111000"),
	[]byte("10111001"),
	[]byte("10111010"),
	[]byte("10111011"),
	[]byte("10111100"),
	[]byte("10111101"),
	[]byte("10111110"),
	[]byte("10111111"),
	[]byte("11000000"),
	[]byte("11000001"),
	[]byte("11000010"),
	[]byte("11000011"),
	[]byte("11000100"),
	[]byte("11000101"),
	[]byte("11000110"),
	[]byte("11000111"),
	[]byte("11001000"),
	[]byte("11001001"),
	[]byte("11001010"),
	[]byte("11001011"),
	[]byte("11001100"),
	[]byte("11001101"),
	[]byte("11001110"),
	[]byte("11001111"),
	[]byte("11010000"),
	[]byte("11010001"),
	[]byte("11010010"),
	[]byte("11010011"),
	[]byte("11010100"),
	[]byte("11010101"),
	[]byte("11010110"),
	[]byte("11010111"),
	[]byte("11011000"),
	[]byte("11011001"),
	[]byte("11011010"),
	[]byte("11011011"),
	[]byte("11011100"),
	[]byte("11011101"),
	[]byte("11011110"),
	[]byte("11011111"),
	[]byte("11100000"),
	[]byte("11100001"),
	[]byte("11100010"),
	[]byte("11100011"),
	[]byte("11100100"),
	[]byte("11100101"),
	[]byte("11100110"),
	[]byte("11100111"),
	[]byte("11101000"),
	[]byte("11101001"),
	[]byte("11101010"),
	[]byte("11101011"),
	[]byte("11101100"),
	[]byte("11101101"),
	[]byte("11101110"),
	[]byte("11101111"),
	[]byte("11110000"),
	[]byte("11110001"),
	[]byte("11110010"),
	[]byte("11110011"),
	[]byte("11110100"),
	[]byte("11110101"),
	[]byte("11110110"),
	[]byte("11110111"),
	[]byte("11111000"),
	[]byte("11111001"),
	[]byte("11111010"),
	[]byte("11111011"),
	[]byte("11111100"),
	[]byte("11111101"),
	[]byte("11111110"),
	[]byte("11111111"),
}
